/*   Program to read a gif image file and write base64 string
     to a text file.

     Copyright (c) 1997 Eolas Technologies Inc.
     Freely modifiable/redistributable under the "Standard Tcl License"
     See http://www.eolas.com/tcl/license.txt for details

     Modified and compiled for 16 bit MS-DOS by Hengbing Duan
     Last modified on Oct. 1, 1997
*/     
   


#include <stdio.h> 
#include <stdlib.h>
#include <io.h>
#include <malloc.h>

#define buffersize 1080 
/* don't change buffersize, it's multiple of 54(3 * 18)
   Only this way, the base64 file is correct for gif file
   with more than 1k.
*/
#define buffersize2 2000

FILE *fpin,*fpout;

void main(int argc, char *argv[])
{  
   int bytes_read,bytes_written,cnt;
   char inbuf[buffersize],outbuf[buffersize2];


   if(argc != 3) {     
      printf("Usage: gifto64 source.gif target.txt\n");
      exit(0);
   }             

   if ((fpin = fopen(argv[1],"r+b")) == NULL) {
      printf("Cant open gifimage %s for reading\n", argv[1]);
      exit(0);
   }
   if ((fpout = fopen(argv[2],"w")) == NULL) {
      printf("Cant open target file %s for writing\n", argv[2]);
      exit(0);
   } 

/* loop 
   each time, 1080 byte is read, and converted into
   exactly 20 line of base 64.
*/      
   while(1) {                                        
     bytes_read = fread(inbuf,sizeof(char),buffersize,fpin);     	   
//     printf("%d\n", bytes_read); 
     cnt = to64(inbuf,outbuf,bytes_read); 
//     printf("%d base64\n", cnt);    
     bytes_written = fwrite(outbuf,sizeof(char),cnt,fpout); 
//     printf("%d bytes out\n", bytes_written);
     if(feof(fpin)) break;      	         
   }   
   if( ferror( fpin ) )       {
      printf( "Read error" );         
   }                  
   
   fclose(fpout);
   fclose(fpin);
   exit(0);	                         
}



