/* (C) Copyright 1993,1994 by Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without
 * fee, provided that the above copyright notice appear in all copies
 * and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of Carnegie
 * Mellon University not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  Carnegie Mellon University makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
/*
Copyright (c) 1991 Bell Communications Research, Inc. (Bellcore)

Permission to use, copy, modify, and distribute this material 
for any purpose and without fee is hereby granted, provided 
that the above copyright notice and this permission notice 
appear in all copies, and that the name of Bellcore not be 
used in advertising or publicity pertaining to this 
material without the specific, prior written permission 
of an authorized representative of Bellcore.  BELLCORE 
MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY 
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", 
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.  */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
int byte_count;
static char basis_64[] =
   "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

int to64(inbuf, outbuf, nchars) 
char *inbuf, *outbuf;
int nchars;
{
//	int c1, c2, c3, ct, ct1, i, bytes_left,limit;
    int ct, ct1, i, bytes_left, limit;
    unsigned char c1, c2, c3;
	limit = 68;

	ct = 0;
	ct1 = 0;
/*
	ct1 = byte_count;
*/
	for(i=0;i<nchars;i+=3)
	{
		bytes_left = nchars - i;

		c1 = *inbuf++;
		if (bytes_left > 1)
			c2 = *inbuf++;
		if (bytes_left > 2)
			c3 = *inbuf++;

		if (bytes_left == 1)
		{
			output64chunk(c1, 0, 0, 2, outbuf);
			outbuf += 4;
		}
		if (bytes_left == 2)
		{
			output64chunk(c1, c2, 0, 1, outbuf);
			outbuf += 4;
		}
		if (bytes_left > 2)
		{
			output64chunk(c1, c2, c3, 0, outbuf);
			outbuf += 4;
		}
		ct += 4;
		ct1 += 4;
		if (ct1 > limit)
		{ 		  
			*outbuf++ = '\n';
			ct1 = 0;
			byte_count = 0;
			ct++;
		}
	}
	if (ct1 <= limit && ct1 != 0)
	{
		byte_count = ct1;
		ct++;
		*outbuf++ = '\n';
	}
	return ct;
}

output64chunk(c1, c2, c3, pads, outbuf)
char *outbuf;
unsigned char c1, c2, c3;
{
    char *savbuf;
    char printbuf[5];
    int i;

    *outbuf++ = basis_64[c1>>2];
//  printf("c1 is %d, index is %d\n", c1, c1>>2);   
//  printf("%c",basis_64[c1>>2]); 
    *outbuf++ = basis_64[((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4)];
//  printf("%c",basis_64[((c1 & 0x3)<< 4) | ((c2 & 0xF0) >> 4)]); 
    if (pads == 2) {
        *outbuf++ = '=';
        *outbuf++ = '=';
    } else if (pads) {
        *outbuf++ = basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)];
        *outbuf++ = '=';
    } else {
        *outbuf++ = basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)];
//  printf("%c", basis_64[((c2 & 0xF) << 2) | ((c3 & 0xC0) >>6)]);      
        *outbuf++ = basis_64[c3 & 0x3F];                        
//  printf("%c\n",basis_64[c3 & 0x3F]);       
    }  
//  getchar();  
}
